
#include "jbc.h"
#include <FlexLexer.h>
#include "jbcparse.hpp"

//vO̍\vf
string MyClassName;
vector<string> IDlist;	//ϐȂǂĂ
vector<string> Strlist; //萔Ă
string NowFunc=string("");
string jbcfile="";
ConstantPool gcp;
ofstream ofs;
FILE *parsefp;

Varlist* gVarlist=NULL; //O[oϐ
FuncVec gFunc,*RTFunc=NULL; //vO̊e֐Qyу^C֐
JFuncVec gJFunc;
StrVec ErrList;

//------------------------------------------------
//C
//------------------------------------------------

extern int yydebug;
extern int yyparse();

void yyerror(char* p){
	char buf[32];
	ErrList.push_back(string("Error [")+itoa(nowline,buf,10)+"]\t"+p);
}

FlexLexer* lexer=NULL;

int yylex() {
	if(lexer) return lexer->yylex();
	else return 0;
}


void main(int argc,char** argv){
	ifstream ifs;
	string fn="";
	int i;
	RTFunc=NULL;
	yydebug=0;
	
	
	//擾
	for(i=1;i<argc;i++){
		if(argv[i][0]=='-'){
			if(argv[i][1]=='d') yydebug=1;
		}
		else fn=string(argv[i]);
	}

	if(fn==""){
		//usage
		cout << "usage : jbc [options] file" << endl;
		cout << "options : -d output parse data" << endl;
		return;
	}
	jbcfile=fn;
	
	//t@Cǂ݂
	if(fn.find('.',0)==-1) MyClassName=fn;
	else MyClassName=fn.substr(0,fn.find('.',0));

	ifs.open(fn.c_str());
	if(ifs.fail()){
		cout << "JBCpt@C [" << fn << "]܂łB" << endl;
    return; 
  } 
	

	
	ofs.open(string(MyClassName+".txt").c_str());
	if(ofs.fail()){
		cout << "t@C [" << MyClassName+".txt" << "]J܂łB" << endl;
    return; 
  }

	parsefp=NULL;
	if(yydebug){
		parsefp=fopen(string(MyClassName+".prs").c_str(),"w");
		if(parsefp==NULL){
			cout << "t@C [" << MyClassName+".prs" << "]J܂łB" << endl;
			return; 
		}
	}

	
	ofs << "CLASSNAME - " << MyClassName << endl;
	ofs << "FILENAME - " << fn <<  endl;
	ofs.flush();

	lexer=new yyFlexLexer(&ifs,NULL);
	gVarlist=NULL;
	
	yyparse();


	
	//\G[
	if(ErrList.size()>0){
		for(StrVec::iterator sit=ErrList.begin();sit!=ErrList.end();sit++){
			cout << *sit << endl;
		}
		goto end;
	}


	ofs << endl;
	ofs << "----------------------------------" << endl;
	ofs << "--Global variables              --" << endl;
	ofs << "----------------------------------" << endl << endl;

	if(gVarlist)	PrintVarlist(gVarlist);

	ofs << endl;
	ofs << "----------------------------------" << endl;
	ofs << "--Function                      --" << endl;
	ofs << "----------------------------------" << endl << endl;

	for_each(gFunc.begin(),gFunc.end(),PrintFunction);

	//̒iKŃ^CNXĂł
	RTFunc=ParseClassFile(RUNTIME_CLASS);

	//Ȍd`FbN
	if(!CheckNameOverlap()){
		for(StrVec::iterator sit=ErrList.begin();sit!=ErrList.end();sit++){
			cout << *sit << endl;
		}
		goto end;
	}

	//I[return
	for_each(gFunc.begin(),gFunc.end(),AddReturn);
	if(ErrList.size()){
		for(StrVec::iterator sit=ErrList.begin();sit!=ErrList.end();sit++){
			cout << *sit << endl;
		}
		goto end;
	}

	//^`FbN
	ofs << "----------------------------------" << endl;
	ofs << "-- Function i^`FbNj    --" << endl;
	ofs << "----------------------------------" << endl << endl;

	if(CheckType()){
		for_each(gFunc.begin(),gFunc.end(),PrintFunction);
	}
	else{
		for(StrVec::iterator sit=ErrList.begin();sit!=ErrList.end();sit++){
			cout << *sit << endl;
		}
		goto end;
	}

	//o
	Output_ExecuteFile();
	if(ErrList.size()){
		for(StrVec::iterator sit=ErrList.begin();sit!=ErrList.end();sit++){
			cout << *sit << endl;
		}
		goto end;
	}


	


end:
	
	if(gVarlist)	DeleteVarlist(gVarlist);
	for_each(gFunc.begin(),gFunc.end(),DeleteFunction);

	JFuncVec::iterator jit;
	for(jit=gJFunc.begin();jit!=gJFunc.end();jit++)	delete (*jit);

	if(RTFunc){
		for_each(RTFunc->begin(),RTFunc->end(),DeleteFunction);
		delete RTFunc;
	}
	if(lexer) delete lexer;
	if(parsefp) fclose(parsefp);
	ifs.close();
	ofs.close();
	
	
}
