
//-----------------------------------------
//JavaRpCp
//-----------------------------------------


#ifndef JBC_JAVA
#define JBC_JAVA

//IyR[ĥgȂ̂
enum JavaOpecode {
	JO_aaload				=	0x32,
	JO_aastore			=	0x53,
	JO_aconst_null	=	0x01,
	JO_aload				=	0x19,
	JO_aload_0			=	0x2a,
	JO_aload_1			=	0x2b,
	JO_aload_2			=	0x2c,
	JO_aload_3			=	0x2d,
	JO_anewarray		=	0xbd,
	JO_areturn			=	0xb0,
	JO_arraylength	=	0xbe,
	JO_astore				=	0x3a,
	JO_astore_0			=	0x4b,
	JO_astore_1			=	0x4c,
	JO_astore_2			=	0x4d,
	JO_astore_3			=	0x4e,
	JO_bipush				=	0x10,
	JO_dup					=	0x59,
	JO_dup_x1				=	0x5a,
	JO_dup_x2				=	0x5b,
	JO_dup2					=	0x5c,
	JO_dup2_x1			=	0x5d,
	JO_dup2_x2			=	0x5e,
	JO_f2i					=	0x8b,
	JO_fadd					=	0x62,
	JO_faload				=	0x30,
	JO_fastore			=	0x51,
	JO_fcmpg				=	0x96,
	JO_fcmpl				=	0x95,
	JO_fconst_0			=	0x0b,
	JO_fconst_1			=	0x0c,
	JO_fconst_2			=	0x0d,
	JO_fdiv					=	0x6e,
	JO_fload				=	0x17,
	JO_fload_0			=	0x22,
	JO_fload_1			=	0x23,
	JO_fload_2			=	0x24,
	JO_fload_3			=	0x25,
	JO_fmul					=	0x6a,
	JO_fneg					=	0x76,
	JO_frem					=	0x72,
	JO_freturn			=	0xae,
	JO_fstore				=	0x38,
	JO_fstore_0			=	0x43,
	JO_fstore_1			=	0x44,
	JO_fstore_2			=	0x45,
	JO_fstore_3			=	0x46,
	JO_fsub					=	0x66,
	JO_getstatic		= 0xb2,
	JO_goto					=	0xa7,
	JO_i2f					=	0x86,
	JO_iadd					=	0x60,
	JO_iaload				=	0x2e,
	JO_iand					=	0x7e,
	JO_iastore			=	0x4f,
	JO_iconst_m1		=	0x02,
	JO_iconst_0			=	0x03,
	JO_iconst_1			=	0x04,
	JO_iconst_2			=	0x05,
	JO_iconst_3			=	0x06,
	JO_iconst_4			=	0x07,
	JO_iconst_5			=	0x08,
	JO_idiv					=	0x6c,
	JO_if_icmpeq		=	0x9f,
	JO_if_icmpne		=	0xa0,
	JO_if_icmplt		=	0xa1,
	JO_if_icmpge		=	0xa2,
	JO_if_icmpgt		=	0xa3,
	JO_if_icmple		=	0xa4,
	JO_ifeq					=	0x99,
	JO_ifne					=	0x9a,
	JO_iflt					=	0x9b,
	JO_ifge					=	0x9c,
	JO_ifgt					=	0x9d,
	JO_ifle					=	0x9e,
	JO_iinc					=	0x84,
	JO_iload				=	0x15,
	JO_iload_0			=	0x1a,
	JO_iload_1			=	0x1b,
	JO_iload_2			=	0x1c,
	JO_iload_3			=	0x1d,
	JO_imul					=	0x68,
	JO_ineg					=	0x74,
	JO_invokeinterface	=	0xb9,
	JO_invokespecial=	0xb7,
	JO_invokestatic	=	0xb8,
	JO_invokevirtual=	0xb6,
	JO_ior					=	0x80,
	JO_irem					=	0x70,
	JO_ireturn			=	0xac,
	JO_ishl					=	0x78,
	JO_ishr					=	0x7a,
	JO_istore				=	0x36,
	JO_istore_0			=	0x3b,
	JO_istore_1			=	0x3c,
	JO_istore_2			=	0x3d,
	JO_istore_3			=	0x3e,
	JO_isub					=	0x64,
	JO_iushr				=	0x7c,
	JO_ixor					=	0x82,
	JO_ldc					=	0x12,
	JO_ldc_w				=	0x13,
	JO_multianewarray=	0xc5,
	JO_new					=	0xbb,
	JO_newarray			=	0xbc,
	JO_nop					=	0x00,
	JO_pop					=	0x57,
	JO_pop2					=	0x58,
	JO_putfield			=	0xb5,
	JO_putstatic		=	0xb3,
	JO_return				=	0xb1,
	JO_sipush				= 0x11,
	JO_swap					= 0x5f,
	JO_wide					=	0xc4,
};
//PƃAZuR[h
//JavãR[hł̓Iyh͍ōQ
struct JavaAsmStruct {
	JavaOpecode op;
	string ops;
	int opi[2];
	char buf[5];
	int offset;
	int size;
};

//x\
typedef map<string,int> AsmLabel;
typedef map<int,int> LineAddr;

//債TCYȂ̂Ń|C^Ȃ܂܂
typedef vector<JavaAsmStruct> VJA;

//ꎞIȃAZui[p
struct Function;
struct JavaAsmFunction {
	VJA vja;
	Function *f;
	AsmLabel label;
	LineAddr la;
	string name;
	int size;
	vector<char> buf;
};

typedef vector<JavaAsmFunction*> JFuncVec;

//RX^gv[
enum ConstantPoolTag {
	CP_UTF8			= 1,
	CP_INTEGER	= 3,
	CP_FLOAT		= 4,
	CP_LONG			= 5,
	CP_DOUBLE		= 6,
	CP_CLASS		= 7,
	CP_STRING		= 8,
	CP_FIELD		= 9,
	CP_METHOD		= 10,
	CP_INTERFACEMETHOD	= 11,
	CP_NAMEANDTYPE	= 12,
};

//RX^gv[
struct CPData{
	ConstantPoolTag tag;
	string stype;
	int ival[2];
	float fval;
	double dval;
	string sval;
};

typedef vector<CPData> ConstantPool;

//֐`
bool Output_ExecuteFile();
void Output_Constructor();
void Output_Function(Function *f);
void Output_InitVariable(JavaAsmFunction *jf,Variable *v,int id);
void Output_CreateInitArray(VJA &vja,Variable *v);
void Output_CreateInitString(VJA &vja);
void Output_Statement(JavaAsmFunction& jf,Statement *s,int &labelcnt,vector<string>& loop_label,vector<string>& for_label,vector<string>& do_label);
void Output_Expression(JavaAsmFunction& jf,Expression *e,int &labelcnt);
void Output_Variable(VJA &vja,Variable *v,Function *f,JavaOpecode jo);
void Output_ClassFile();
void Output_ConstantPool(FILE *f,CPData &cp);
void Output_ArrangeOpecode(JavaAsmFunction& jaf);
void Output_Branch(VJA &vja,int type,int cmp,bool b_ift,string label);

int ConstantPool_Add(ConstantPool& cp,ConstantPoolTag tag,string cps="",string cps2="",int cpi=0,float cpf=0.0,string cps3="");
void AddJavaAsmStruct(VJA &vja,JavaOpecode op,string ops="",int opi1=0,int opi2=0);





//IyR[hʂ̃TCY
static int JOpSize[256]={
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	2,3,2,3,3,2,2,2,2,2,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,
	3,3,3,3,3,3,3,3,3,2,0,0,1,1,1,1,
	1,1,3,3,3,3,3,3,3,3,0,3,2,3,1,1,
	3,3,1,1,4,4,3,3,5,5,-1,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1
};


static OpTable JOPTable[]={
	{0x32,"JO_aaload"},
	{0x53,"JO_aastore"},
	{0x01,"JO_aconst_null"},
	{0x19,"JO_aload"},
	{0x2a,"JO_aload_0"},
	{0x2b,"JO_aload_1"},
	{0x2c,"JO_aload_2"},
	{0x2d,"JO_aload_3"},
	{0xbd,"JO_anewarray"},
	{0xb0,"JO_areturn"},
	{0xbe,"JO_arraylength"},
	{0x3a,"JO_astore"},
	{0x4b,"JO_astore_0"},
	{0x4c,"JO_astore_1"},
	{0x4d,"JO_astore_2"},
	{0x4e,"JO_astore_3"},
	{0x10,"JO_bipush"},
	{0x59,"JO_dup"},
	{0x5a,"JO_dup_x1"},
	{0x5b,"JO_dup_x2"},
	{0x5c,"JO_dup2"},
	{0x5d,"JO_dup2_x1"},
	{0x5e,"JO_dup2_x2"},
	{0x8b,"JO_f2i"},
	{0x62,"JO_fadd"},
	{0x30,"JO_faload"},
	{0x51,"JO_fastore"},
	{0x96,"JO_fcmpg"},
	{0x95,"JO_fcmpl"},
	{0x0b,"JO_fconst_0"},
	{0x0c,"JO_fconst_1"},
	{0x0d,"JO_fconst_2"},
	{0x6e,"JO_fdiv"},
	{0x17,"JO_fload"},
	{0x22,"JO_fload_0"},
	{0x23,"JO_fload_1"},
	{0x24,"JO_fload_2"},
	{0x25,"JO_fload_3"},
	{0x6a,"JO_fmul"},
	{0x76,"JO_fneg"},
	{0x72,"JO_frem"},
	{0xae,"JO_freturn"},
	{0x38,"JO_fstore"},
	{0x43,"JO_fstore_0"},
	{0x44,"JO_fstore_1"},
	{0x45,"JO_fstore_2"},
	{0x46,"JO_fstore_3"},
	{0x66,"JO_fsub"},
	{0xb2,"JO_getstatic"},
	{0xa7,"JO_goto"},
	{0x86,"JO_i2f"},
	{0x60,"JO_iadd"},
	{0x2e,"JO_iaload"},
	{0x7e,"JO_iand"},
	{0x4f,"JO_iastore"},
	{0x02,"JO_iconst_m1"},
	{0x03,"JO_iconst_0"},
	{0x04,"JO_iconst_1"},
	{0x05,"JO_iconst_2"},
	{0x06,"JO_iconst_3"},
	{0x07,"JO_iconst_4"},
	{0x08,"JO_iconst_5"},
	{0x6c,"JO_idiv"},
	{0x9f,"JO_if_icmpeq"},
	{0xa0,"JO_if_icmpne"},
	{0xa1,"JO_if_icmplt"},
	{0xa2,"JO_if_icmpge"},
	{0xa3,"JO_if_icmpgt"},
	{0xa4,"JO_if_icmple"},
	{0x99,"JO_ifeq"},
	{0x9a,"JO_ifne"},
	{0x9b,"JO_iflt"},
	{0x9c,"JO_ifge"},
	{0x9d,"JO_ifgt"},
	{0x9e,"JO_ifle"},
	{0x84,"JO_iinc"},
	{0x15,"JO_iload"},
	{0x1a,"JO_iload_0"},
	{0x1b,"JO_iload_1"},
	{0x1c,"JO_iload_2"},
	{0x1d,"JO_iload_3"},
	{0x68,"JO_imul"},
	{0x74,"JO_ineg"},
	{0xb9,"JO_invokeinterface"},
	{0xb7,"JO_invokespecial"},
	{0xb8,"JO_invokestatic"},
	{0xb6,"JO_invokevirtual"},
	{0x80,"JO_ior"},
	{0x70,"JO_irem"},
	{0xac,"JO_ireturn"},
	{0x78,"JO_ishl"},
	{0x7a,"JO_ishr"},
	{0x36,"JO_istore"},
	{0x3b,"JO_istore_0"},
	{0x3c,"JO_istore_1"},
	{0x3d,"JO_istore_2"},
	{0x3e,"JO_istore_3"},
	{0x64,"JO_isub"},
	{0x7c,"JO_iushr"},
	{0x82,"JO_ixor"},
	{0x12,"JO_ldc"},
	{0x13,"JO_ldc_w"},
	{0xc5,"JO_multianewarray"},
	{0xbb,"JO_new"},
	{0xbc,"JO_newarray"},
	{0x00,"JO_nop"},
	{0x57,"JO_pop"},
	{0x58,"JO_pop2"},
	{0xb5,"JO_putfield"},
	{0xb3,"JO_putstatic"},
	{0xb1,"JO_return"},
	{0x11,"JO_sipush"},
	{0x5f,"JO_swap"},
	{0xc4,"JO_wide"}
};

#endif