
#include "jbc.h"

//------------------------------------------------
//͌ʏo
//------------------------------------------------

void PrintVarlist(Varlist *vl){
	Varlist::iterator it;
	if(vl==NULL) return;
	if(vl->size()>0){
		for(it=vl->begin();	it!=vl->end();	it++){
			ofs << "[" << (*it)->lineno << "] \t" << (*it)->name << " As ";
			PrintType(&(*it)->type);
			ofs << endl;
		}
	}
}

void PrintType(Type *t){
	switch(t->type){
	case T_INT:
		ofs << "int";
		break;
	case T_FLOAT:
		ofs << "float";
		break;
	case T_STRING:
		ofs << "string";
		break;
	case T_VOID:
		ofs << "void";
		break;
	}

	for(vector<int>::iterator it=t->arraydepth.begin();it!=t->arraydepth.end();it++){
		ofs << "[";
		if(*it>=0) ofs << *it;
		ofs << "]";
	}

}

string TypeToString(Type *t){
	string s;
	switch(t->type){
	case T_INT:
		s="int";
		break;
	case T_FLOAT:
		s="float";
		break;
	case T_STRING:
		s="string";
		break;
	case T_VOID:
		s="void";
		break;
	}

	for(vector<int>::iterator it=t->arraydepth.begin();it!=t->arraydepth.end();it++){
		s+="[]";
	}
	return s;

}

void PrintExpression(Expression* e,string indent){
	ExprVec::iterator it;
	char buf[256];
	int i;

	if(e==NULL){
		ofs << "NULL";
		return;
	}
	
	ofs << indent;
	switch(e->exprtype){
	case T_ID:
		ofs << IDlist[e->index];
		for(it=e->elist.begin();it!=e->elist.end();it++){
			ofs << "[";
			PrintExpression(*it);
			ofs << "]";
		}


		break;
	case T_CALL:
		ofs << IDlist[e->index];
		ofs << "(";
		for(it=e->elist.begin();it!=e->elist.end();it++){
			if(it!=e->elist.begin()) ofs << ", ";
			PrintExpression(*it);
		}
		ofs << ")";
		break;

	case T_CONST:
		switch(e->type){
		case T_INT:
			ofs << e->ival;
			break;
		case T_FLOAT:
			ofs << e->fval;

			break;
		case T_STRING:
			ofs << "\"" << Strlist[e->index] << "\"";
		}
		break;
	case T_OP2:
		ofs << "(";
		PrintExpression(e->elist[0]);
		for(i=0;i<sizeof(OPTable)/sizeof(OpTable);i++){
			if(e->type==OPTable[i].index){
				ofs << OPTable[i].str;
				break;
			}
		}
		if(i==sizeof(OPTable)/sizeof(OpTable)) ofs << "y" << e->type << "z";
		PrintExpression(e->elist[1]);
		ofs << ")";
		break;
	case T_OP1:
		ofs << "(";
		for(i=0;i<sizeof(OPTable)/sizeof(OpTable);i++){
			if(e->type==OPTable[i].index){
				ofs << OPTable[i].str;
				break;
			}
		}
		if(i==sizeof(OPTable)/sizeof(OpTable)) ofs << "y" << e->type << "z";
		PrintExpression(e->elist[0]);
		ofs << ")";
		break;
	case T_TYPE:
		switch(e->type){
		case T_INT:
			ofs << "(int)";
			break;
		case T_FLOAT:
			ofs << "(float)";
			break;
		case T_STRING:
			ofs << "(string)";
			break;
		}
		PrintExpression(e->elist[0]);
		break;
	}

}

void PrintStatement(Statement* s,string indent,bool ShowLine){
	ExprVec::iterator eit;
	StmtVec::iterator sit;
	Expression *te;
	int i;

	if(s==NULL){
		ofs << "NULL";
		return;
	}

	switch(s->stmttype){
	case T_CALL:
		if(ShowLine) ofs << "[" << s->lineno << "] \t";		
		ofs << indent << "CALL " << IDlist[s->exprlist[0]->index] << "(";
		for(eit=(s->exprlist.begin()+1);eit!=s->exprlist.end();eit++){
			if(eit!=(s->exprlist.begin()+1)) ofs << " , ";
			PrintExpression(*eit);
		}
		ofs << ")" << endl;
		break;

	case T_REDIM:
		if(ShowLine) ofs << "[" << s->lineno << "] \t";		
		ofs << indent << "REDIM " << IDlist[s->exprlist[0]->index];
		for(eit=(s->exprlist.begin()+1);eit!=s->exprlist.end();eit++){
			ofs << "[";
			PrintExpression(*eit);
			ofs << "]";
		}
		ofs << endl;
		break;

	case T_SUBST:
		if(ShowLine) ofs << "[" << s->lineno << "] \t";		
		ofs << indent;
		PrintExpression(s->exprlist[0]);
		ofs << " = ";
		PrintExpression(s->exprlist[1]);
		ofs << endl;
		break;

	case T_EXIT:
		if(ShowLine) ofs << "[" << s->lineno << "] \t";		
		switch(s->subtype){
		case T_FOR:
			ofs << "EXIT FOR" << endl;
			break;
		case T_DO:
			ofs << "EXIT DO" << endl;
			break;
		}
		break;

	case T_RETURN:
		if(ShowLine) ofs << "[" << s->lineno << "] \t";		
		ofs << indent <<"return";
		if(s->exprlist.size()>0){
			ofs << " (";
			for(eit=s->exprlist.begin();eit!=s->exprlist.end();eit++){
				if(eit!=s->exprlist.begin()) ofs << " , ";
				PrintExpression(*eit);
			}
			ofs << ")";
		}
		ofs << endl;
		break;

	case T_CONTINUE:
		if(ShowLine) ofs << "[" << s->lineno << "] \t";		
		ofs << indent << "continue" << endl;
		break;

	case T_IF:
		if(ShowLine) ofs << "[" << s->lineno << "] \t";		
		ofs << indent;

		if(s->stmtlist[0]->stmttype != T_LIST){
			//1sif
			ofs << "IF ";
			PrintExpression(s->exprlist[0]);
			ofs << " THEN ";
			PrintStatement(s->stmtlist[0],"",false);
		}
		else{
			//sif
			ofs << "IF ";
			PrintExpression(s->exprlist[0]);
			ofs << " THEN " << endl;
			PrintStatement(s->stmtlist[0],indent+"  ");

			//elseifQ
			for(i=1;i<s->exprlist.size();i++){
				if(ShowLine) ofs << "[" << s->lineno << "] \t";		
				ofs << indent << "ELSEIF ";
				PrintExpression(s->exprlist[1]);
				ofs << " THEN" << endl;
				PrintStatement(s->stmtlist[s->stmtlist.size()-1],indent+"  ");
			}


			if(s->exprlist.size() != s->stmtlist.size()){
				if(ShowLine) ofs << "[" << s->lineno << "] \t";		
				ofs << indent << "ELSE" << endl;
				PrintStatement(s->stmtlist[s->stmtlist.size()-1],indent+"  ");
			}
			if(ShowLine) ofs << "[" << s->lineno << "] \t";		
			ofs << indent << "END IF" << endl;
		}
		break;

	case T_LIST:
		for(sit=s->stmtlist.begin();sit!=s->stmtlist.end();sit++)
			PrintStatement(*sit,indent);
		break;

	case T_FOR:
		//FOR
		if(ShowLine) ofs << "[" << s->lineno << "] \t";		
		ofs << indent << "FOR ";
		PrintExpression(s->exprlist[0]);
		ofs << " = ";
		PrintExpression(s->exprlist[1]);
		ofs << " TO ";
		PrintExpression(s->exprlist[2]);
		if(s->exprlist.size()>3){
			ofs << " STEP ";
			PrintExpression(s->exprlist[3]);
		}
		ofs << endl;
		for(sit=s->stmtlist.begin();sit!=s->stmtlist.end();sit++)
			PrintStatement(*sit,indent+"  ");
		if(ShowLine) ofs << "[" << s->lineno << "] \t";		
		ofs << indent << "next" << endl;
		break;

	case T_DO:
		//DO LOOP
		if(ShowLine) ofs << "[" << s->lineno << "] \t";		
		ofs << indent << "DO";
		//
		te=s->exprlist[0];
		if(te->index==T_WHILE && te->type==T_INT && te->ival==1){
		}
		else if(te->index==T_UNTIL){
			ofs << " UNTIL ";
			PrintExpression(te);
		}
		else{
			ofs << " WHILE ";
			PrintExpression(te);
		}
		ofs << endl;
		for(sit=s->stmtlist.begin();sit!=s->stmtlist.end();sit++)
			PrintStatement(*sit,indent+"  ");
		if(ShowLine) ofs << "[" << s->lineno << "] \t";		
		ofs << indent << "LOOP";
		//
		te=s->exprlist[1];
		if(te->index==T_WHILE && te->type==T_INT && te->ival==1){
		}
		else if(te->index==T_UNTIL){
			ofs << " UNTIL ";
			PrintExpression(te);
		}
		else{
			ofs << " WHILE ";
			PrintExpression(te);
		}
		ofs << endl;

		break;


	}

}

void PrintFunction(Function *f){
	Varlist::iterator vit;
	StmtVec::iterator sit;

	//֐
	ofs << "[" << f->lineno[0] << "] \t";		
	if(f->rettype.type==T_VOID){
		ofs << "Sub " << f->name << "(";
		for(vit=f->args.begin(); vit!=f->args.end(); vit++){
			if(vit!=f->args.begin()) ofs << ",";
			ofs << (*vit)->name << " As ";
			PrintType(&(*vit)->type);
		}
	
		ofs << ")" << endl;
	}
	else{
		ofs << "Function " << f->name << "(";
		for(vit=f->args.begin(); vit!=f->args.end(); vit++){
			if(vit!=f->args.begin()) ofs << ",";
			ofs << (*vit)->name << " As ";
			PrintType(&(*vit)->type);
		}
	
		ofs << ") As ";
		PrintType(&f->rettype);
		ofs << endl;
	}

	PrintVarlist(&f->vl);

	ofs << endl;
	for(sit=f->plist.begin();sit!=f->plist.end();sit++)
		PrintStatement(*sit,"  ",true);

	ofs << endl;
	ofs << "[" << f->lineno[1] << "] \t";		
	if(f->rettype.type==T_VOID)	ofs << "End Sub" << endl << endl;
	else ofs << "End Function" << endl << endl;

}


//------------------------------------------------
//ϐ̏d`FbN
//------------------------------------------------

bool CheckNameOverlap(){
	FuncVec::iterator fit,fit2;
	Varlist::iterator vit;
	char buf[256];
	vector<string> erl;
	
	ErrList.clear();
	
	//֐̂̏d`FbN
	for(fit=gFunc.begin();fit!=gFunc.end()-1;fit++){
		for(fit2=fit+1;fit2!=gFunc.end();fit2++){
			if((*fit)->name == (*fit2)->name){
				//Ɍxς݂̊֐ȂǂȂ
				if(find(erl.begin(),erl.end(),(*fit)->name)==erl.end()){
					sprintf(buf,"֐[ %s ]`Ă܂B",(*fit)->name.c_str());
					ErrList.push_back(buf);
					erl.push_back((*fit)->name);
				}
			}
		}
	}
	//O[oϐƃO[o֐̏d`FbN
	for(fit=gFunc.begin();fit!=gFunc.end();fit++){
		for(vit=gVarlist->begin();vit!=gVarlist->end();vit++){
			if((*fit)->name == (*vit)->name){
				//Ɍxς݂̊֐ȂǂȂ
				if(find(erl.begin(),erl.end(),(*fit)->name)==erl.end()){
					sprintf(buf,"O[oϐE֐[ %s ]`Ă܂B",(*fit)->name.c_str());
					ErrList.push_back(buf);
					erl.push_back((*fit)->name);
				}
			}
		}
	}
	
	//O[oȕϐQɂă`FbN
	CheckNameOverlap_Sub(gVarlist,NULL,NULL);

	//֐ƂɃ`FbN
	for(fit=gFunc.begin();fit!=gFunc.end();fit++)
		CheckNameOverlap_Sub(&((*fit)->vl),&((*fit)->args),*fit);
	
	//G[false
	return (ErrList.size()==0);
}

//֐̕ϐQ`FbN
void CheckNameOverlap_Sub(Varlist* vl1,Varlist* vl2,Function* f){
	int i,j,ms;
	Variable *v1,*v2;
	vector<string> erl;
	char buf[256];

	erl.clear();
	ms=vl1->size();
	if(vl2) ms+=vl2->size();
	for(i=0;i<ms-1;i++){
		for(j=i+1;j<ms;j++){
			v1=(i<vl1->size() ? (*vl1)[i] : (*vl2)[i-vl1->size()]);
			v2=(j<vl1->size() ? (*vl1)[j] : (*vl2)[j-vl1->size()]);
			//Od
			if(v1->name == v2->name){
				//ɃG[񍐂̂閼OȂ炻ȏ̏͂Ȃ
				if(find(erl.begin(),erl.end(),v1->name)==erl.end()){
					if(f==NULL) sprintf(buf,"O[oϐ[ %s ]`Ă܂B",v1->name.c_str());
					else sprintf(buf,"֐[ %s ]ŕϐ[ %s ]`Ă܂B",f->name.c_str(),v1->name.c_str());
					ErrList.push_back(buf);
					erl.push_back(v1->name.c_str());
				}
			}
		}
	}
}












//------------------------------------------------
//|C^
//------------------------------------------------

void DeleteVarlist(Varlist* vl){
	Varlist::iterator it;
	if(vl==NULL) return;
	if(vl->size()>0){
		for(it=vl->begin();	it!=vl->end();	it++)
			delete (*it);
	}
	delete vl;
}

void DeleteExpression(Expression* e){
	if(e==NULL) return;
	for(ExprVec::iterator it=e->elist.begin();it!=e->elist.end();it++){
		DeleteExpression(*it);
	}
	delete e;
}

void DeleteStatement(Statement* s){
	if(s==NULL) return;

	for(StmtVec::iterator sit=s->stmtlist.begin();sit!=s->stmtlist.end();sit++){
		DeleteStatement(*sit);
	}
	for(ExprVec::iterator eit=s->exprlist.begin();eit!=s->exprlist.end();eit++){
		DeleteExpression(*eit);
	}

	delete s;
}

void DeleteFunction(Function *f){
	Varlist::iterator vit;
	
	for(vit=f->args.begin();vit!=f->args.end();vit++) delete (*vit);
	for(vit=f->vl.begin();vit!=f->vl.end();vit++) delete (*vit);
	for_each(f->plist.begin(),f->plist.end(),DeleteStatement);
	delete f;
}

//------------------------------------------------
//IDFX擾
//------------------------------------------------

//IDo^AID擾
int GetIndexfromIDList(vector<string>* sl,char* buf){
	string s(buf);
	int i;

	//intňʒu~̂STL̊֐͎gȂ
	for(i=0;i<sl->size();i++){
		if((*sl)[i]==s) return i;
	}

	sl->push_back(s);
	return sl->size()-1;
}


//IDϐ擾
Variable* GetVariableFromString(string id,Function *f){
	Varlist::iterator vit;

	
	if(f){
		//[Jϐ擾

		//猟
		for(vit=f->args.begin();vit!=f->args.end();vit++){
			if((*vit)->name==id) return (*vit);
		}

		//錾猟
		for(vit=f->vl.begin();vit!=f->vl.end();vit++){
			if((*vit)->name==id) return (*vit);
		}
		//炸
		return NULL;
	}
	else{
		//O[oϐ擾
		for(vit=gVarlist->begin();vit!=gVarlist->end();vit++){
			if((*vit)->name==id) return (*vit);
		}
		return NULL;
	}
}

//ID֐擾
Function* GetFunctionFromString(string id){
	FuncVec::iterator fit;

	//NX֐猟
	for(fit=gFunc.begin();fit!=gFunc.end();fit++){
		if(id==(*fit)->name) return *fit;
	}

	//^CNX猟
	for(fit=RTFunc->begin();fit!=RTFunc->end();fit++){
		if(id==(*fit)->name) return *fit;
	}
	return NULL;
}

//ϐ烍[JϐIDɕϊ
int GetVariableIDFromString(string id,Function *f){
	int i;
	
	//[Jϐ擾

	//猟
	for(i=0;i<f->args.size();i++){
		if(f->args[i]->name==id) return i;
	}

	//錾猟
	for(i=0;i<f->vl.size();i++){
		if(f->vl[i]->name==id) return i+f->args.size();
	}
	//炸
	return -1;
}

//------------------------------------------------
//֐̏I[returnɂ
//------------------------------------------------

void AddReturn(Function *f){
	Statement *s;
	Expression *e;
	//I[returnȂ牽Ȃ
	if(f->plist.size()>0 && f->plist[f->plist.size()-1]->stmttype==T_RETURN) return;

	//SUB͔z񂵂ĂȂPȂreturn(nullԂ)
	s=new Statement;
	s->lineno=-1;
	s->stmttype=T_RETURN; 
	
	//zESUBȂNULLw
	if(f->rettype.arraydepth.size()==0 && f->rettype.type!=T_VOID){
		e=new Expression;
		e->lineno=-1;
		e->exprtype=T_CONST;
		e->type=f->rettype.type;
		e->ival=0;
		e->fval=0;
		if(f->rettype.type==T_STRING){
			e->index=GetIndexfromIDList(&Strlist,"");
		}
		s->exprlist.push_back(e);
	}
	f->plist.push_back(s);
	return;
}