
#include "jbc.h"
#include "jbcjava.h"

//oCgI[_[̌
template<typename T> T ChangeBO(T ti){
	T to;
	int i,l=sizeof(T);
	for(i=0;i<l;i++) ((char*)&to)[i]=((char*)&ti)[l-i-1];
	return to;
}



int utf16to8(unsigned char *to,unsigned short *from){
	short s;
	int i=0;
	while(*from){
		s=*from++;

		//9bit
		if((s & 0xFF80) == 0){
			*to++=(unsigned char)(s & 0x7F);
			i++;
		}
		else if((s & 0xF800) == 0){
			//5bit
			*to++=0xC0 | ((s & 0x7C0)>>6);
			*to++=0x80 | (s & 0x3F);
			i+=2;
		}
		else{
			*to++=0xE0 | ((s & 0xF000)>>12);
			*to++=0x80 | ((s & 0xFC0)>>6);
			*to++=0x80 | (s & 0x3F);
			i+=3;
		}
	}
	return i;
}

int utf8tosjis(char *to,const char *from){
	char s;
	int i=0,j;
	unsigned short buf[1024];

	memset(buf,0,sizeof(buf));
	//܂UTF8UTF16
	while(*from){
		s=*from++;

		//ŏʃrbg΂QoCgȏ
		if(s & 0x80){
			//RrbgĂ邩H
			if(s & 0x20){
				//RoCg
				buf[i++]=(((short)s&0xF)<<12) | (((short)*from++ & 0x3F) << 6) | (((short)*from++ & 0x3F));
			}
			else{
				//QoCg
				buf[i++]=(((short)s&0x1F)<<6) | (((short)*from++ & 0x3F));
			}
		}
		else{
			buf[i++]=s;
		}
	}

	//UTF-16ShiftJIS
	setlocale(LC_ALL, "Japanese");	// ꂪȂUnicodeɕϊȂI
	j=wcstombs(NULL,(wchar_t*)buf,i*2);
	wcstombs(to,(wchar_t*)buf,j);
	to[j]=0;
	// VC2005̃oOŁAlocale߂Ȃcout{o͂Ȃ
	setlocale( LC_ALL, "C" ); 

	return j;
}

int sjistoutf8(char *to,const char *from){
	char s;
	int i=0,j;
	unsigned short buf[1024];

	//ShiftJISUTF-16
	setlocale(LC_ALL, "Japanese");	// ꂪȂUnicodeɕϊȂI
	j=mbstowcs(NULL,from,strlen(from));
	mbstowcs((wchar_t*)buf,from,strlen(from));
	buf[j]=0;
	// VC2005̃oOŁAlocale߂Ȃcout{o͂Ȃ
	setlocale( LC_ALL, "C" ); 

	return utf16to8((unsigned char*)to,buf);
}

string CreateJavaTypeString(Function *pf){
	string ts="(";
	int i;
	for(i=0;i<pf->args.size();i++) ts+=CreateJavaTypeString(&(pf->args[i]->type));
	ts+=")";
	ts+=CreateJavaTypeString(&(pf->rettype));

	return ts;
}

string CreateJavaTypeString(Type *pt){
	//Javǎ^ɒ
	string ts="";
	int i;
	
	//z[i]
	for(i=0;i<pt->arraydepth.size();i++) ts+="[";

	switch(pt->type){
	case T_INT:
		ts+="I";
		break;
	case T_FLOAT:
		ts+="F";
		break;
	case T_STRING:
		ts+="Ljava/lang/String;";
		break;
	case T_VOID:
		ts+="V";
		break;
	}
	return ts;

}










void ParseTypeString(Function *pf,string ts){
	const char* pc=ts.c_str();
	char c,buf[16];
	int i=0;
	int depth=0;
	bool isok=true;
	Variable *pv;



	if(*pc++!='(') return;
	
	//ʂI܂
	while((c=*pc)!=')'){
		i++;

		switch(c){
		//z
		case '[':
			depth++;
			break;
		case 'I':
		case 'J':
			//int,long
			pv=new Variable;
			for(i=0;i<depth;i++) pv->type.arraydepth.push_back(-1);
			pv->type.type=T_INT;
			itoa(pf->args.size(),buf,10);
			pf->args.push_back(pv);
			i=depth=0;
			pc++;
			break;
		case 'F':
			//int,long
			pv=new Variable;
			for(i=0;i<depth;i++) pv->type.arraydepth.push_back(-1);
			pv->type.type=T_FLOAT;
			itoa(pf->args.size(),buf,10);
			pf->args.push_back(pv);
			i=depth=0;
			pc++;
			break;
		case 'L':
			//StringӊO͔r
			i=strlen("Ljava/lang/String;");
			if(strncmp(pc,"Ljava/lang/String;",i)==0){
				pc+=i;
				pv=new Variable;
				for(i=0;i<depth;i++) pv->type.arraydepth.push_back(-1);
				pv->type.type=T_STRING;
				itoa(pf->args.size(),buf,10);
				pf->args.push_back(pv);
				i=depth=0;
			}
			else{
				isok=false;
				goto endloop;
			}
			break;
		default:
			isok=false;
			goto endloop2;
			break;
		}
		
	}
endloop:

	i=depth=0;
	if(isok && *pc++==')'){
		
		while((c=*pc++)){
			i++;

			switch(c){
			//z
			case '[':
				depth++;
				break;
			case 'V':
				//void
				for(i=0;i<depth;i++) pf->rettype.arraydepth.push_back(-1);
				pf->rettype.type=T_VOID;
				goto endloop2;
			case 'I':
			case 'J':
				//int,long
				for(i=0;i<depth;i++) pf->rettype.arraydepth.push_back(-1);
				pf->rettype.type=T_INT;
				goto endloop2;
				break;
			case 'F':
				//float
				for(i=0;i<depth;i++) pf->rettype.arraydepth.push_back(-1);
				pf->rettype.type=T_FLOAT;
				goto endloop2;
				break;
			case 'L':
				//StringӊO͔r
				i=strlen("Ljava/lang/String;");
				if(strncmp(pc,"Ljava/lang/String;",i)==0){
					for(i=0;i<depth;i++) pf->rettype.arraydepth.push_back(-1);
					pf->rettype.type=T_STRING;
					goto endloop2;
				}
				else{
					isok=false;
					goto endloop2;
				}
				break;
			default:
				isok=false;
				goto endloop2;
				break;
			}
		}
	}
endloop2:

	//intAfloatAstringӊO
	if(!isok){
		for(Varlist::iterator vit=pf->args.begin();vit!=pf->args.end();vit++)
			delete (*vit);
		pf->name="";
	}

}





//classt@C̕
//֐ꗗ擾
FuncVec* ParseClassFile(char* fn){
	FILE* f;
	int i,j,k;
	char buf[256],buf2[256];
	short sbuf[256];
	short s;
	float fl;
	double d;
	CPData cpd;
	ConstantPool cp;
	FuncVec *vf=new FuncVec();
	Function *pf;
	Variable *pv;
	bool doprint=true;

	short ncp,nif,nfl,nmt,nat;

	f=fopen(fn,"rb");
	//wb_
	fread(&i,4,1,f);

	if(doprint){
		ofs << "------------------------------------" << endl;
		ofs << "-- parse RTClass.class            --" << endl;
		ofs << "------------------------------------" << endl << endl;
	}

	if(doprint) ofs << "MAGIC_NUM - " << hex << ChangeBO(i) << endl;
	fread(sbuf,4,1,f);
	if(doprint) ofs << "minor - " << dec << ChangeBO(sbuf[0]) << endl;
	if(doprint) ofs << "major - " << dec << ChangeBO(sbuf[0]) << endl;
	//RX^gv[
	fread(&ncp,2,1,f);
	ncp=ChangeBO(ncp);
	cp.clear();
	cp.push_back(cpd);

	if(doprint) ofs << "NUM(constant pool) - " << ncp << endl;
	for(i=1;i<ncp;i++){
		fread(buf,1,1,f);
		cpd.tag=(ConstantPoolTag)buf[0];

		switch(buf[0]){
		case CP_UTF8:
			//
			fread(&s,2,1,f);
			fread(buf,ChangeBO(s),1,f);
			buf[ChangeBO(s)]=0;
			utf8tosjis(buf2,buf);
			cpd.stype="utf8";
			cpd.sval=buf2;
			
			break;

		case CP_INTEGER:
			//int
			fread(&j,4,1,f);
			cpd.stype="int";
			cpd.ival[0]=ChangeBO(j);
			break;
		case CP_FLOAT:
			//float
			fread(&fl,4,1,f);
			cpd.stype="float";
			cpd.fval=ChangeBO(fl);
			break;
		case CP_LONG:
			fseek(f,8,SEEK_CUR);
			cpd.stype="long int";
			i++;
			break;
		case CP_DOUBLE:
			fread(&d,8,1,f);
			cpd.stype="double";
			cpd.dval=ChangeBO(d);
			i++;
			break;
		case CP_CLASS:
			fread(&s,2,1,f);
			cpd.stype="class";
			cpd.ival[0]=ChangeBO(s);
			break;
		case CP_STRING:
			fread(&s,2,1,f);
			cpd.stype="string";
			cpd.ival[0]=ChangeBO(s);
			break;
		case CP_FIELD:
			fread(sbuf,2,2,f);
			cpd.stype="field";
			cpd.ival[0]=ChangeBO(sbuf[0]);
			cpd.ival[1]=ChangeBO(sbuf[1]);
			break;
		case CP_METHOD:
			fread(sbuf,2,2,f);
			cpd.stype="method";
			cpd.ival[0]=ChangeBO(sbuf[0]);
			cpd.ival[1]=ChangeBO(sbuf[1]);
			break;
		case CP_INTERFACEMETHOD:
			fread(sbuf,2,2,f);
			cpd.stype="interface";
			cpd.ival[0]=ChangeBO(sbuf[0]);
			cpd.ival[1]=ChangeBO(sbuf[1]);
			break;
		case CP_NAMEANDTYPE:
			fread(sbuf,2,2,f);
			cpd.stype="name_type";
			cpd.ival[0]=ChangeBO(sbuf[0]);
			cpd.ival[1]=ChangeBO(sbuf[1]);
			break;
		default:
			break;
		}
		cp.push_back(cpd);
	}
	
	if(doprint) PrintConstantPool(cp);
	

	//
	fread(sbuf,4,2,f);
	if(doprint) ofs << "access_flag - 0x"			<< hex << ChangeBO(sbuf[0]) << endl;
	if(doprint) ofs << "this_class - "				<< dec << ChangeBO(sbuf[1]) << endl;
	if(doprint) ofs << "super_class - "			<< dec << ChangeBO(sbuf[2]) << endl;
	if(doprint) ofs << "interface_count - "	<< dec << (nif=ChangeBO(sbuf[3])) << endl;
	for(i=0;i<nif;i++){
		fread(&s,2,1,f);
		if(doprint) ofs << "IF [" << dec << i << "] - " << cp[cp[ChangeBO(s)].ival[0]].sval << endl;
	}

	//tB[hf[^
	fread(&s,2,1,f);
	nfl=ChangeBO(s);
	for(i=0;i<nfl;i++){
		fread(sbuf,2,4,f);
		if(doprint) ofs << "Field[" << dec << i <<"]";
		if(doprint) ofs << " - access(0x" << hex << ChangeBO(sbuf[0]) << ")";
		if(doprint) ofs << " name(" << cp[ChangeBO(sbuf[1])].sval << ")";
		if(doprint) ofs << " desc(" << cp[ChangeBO(sbuf[2])].sval << ")";
		if(doprint) ofs << " nattr(" << dec << ChangeBO(sbuf[3]) << ")" << endl;
		//Agr[g΂
		nat=ChangeBO(sbuf[3]);
		for(j=0;j<nat;j++){
			fread(&s,2,1,f);
			if(doprint) ofs << "  ATR[" << dec << j << "]\t:" << cp[ChangeBO(s)].sval << endl;
			fread(&k,4,1,f);
			fseek(f,ChangeBO(k),SEEK_CUR);
		}
	}

	//\bh
	fread(&s,2,1,f);
	nmt=ChangeBO(s);
	for(i=0;i<nmt;i++){
		fread(sbuf,2,4,f);
		if(doprint) ofs << "Method[" << dec << i <<"]";
		if(doprint) ofs << " - access(0x" << hex << ChangeBO(sbuf[0]) << ")";
		if(doprint) ofs << " name(" << cp[ChangeBO(sbuf[1])].sval << ")";
		if(doprint) ofs << " desc(" << cp[ChangeBO(sbuf[2])].sval << ")";
		if(doprint) ofs << " nattr(" << dec << ChangeBO(sbuf[3]) << ")" << endl;
		//publicstaticȂ֐ꗗɒǉ
		if(ChangeBO(sbuf[0]) == 9){
			pf=new Function;
			pf->name=cp[ChangeBO(sbuf[1])].sval;
			pf->local=false;
			ParseTypeString(pf,cp[ChangeBO(sbuf[2])].sval);
			if(pf->name == "")	delete pf;
			else	vf->push_back(pf);
		}
		//Agr[g΂
		nat=ChangeBO(sbuf[3]);
		for(j=0;j<nat;j++){
			fread(&s,2,1,f);
			if(doprint) ofs << "  ATR[" << dec << j << "]\t:" << cp[ChangeBO(s)].sval << endl;
			fread(&k,4,1,f);
			fseek(f,ChangeBO(k),SEEK_CUR);
		}
	}

	//Agr[g΂
	fread(&s,2,1,f);
	nat=ChangeBO(s);
	for(j=0;j<nat;j++){
		fread(&s,2,1,f);
		if(doprint) ofs << "ATR[" << dec << j << "]\t:" << cp[ChangeBO(s)].sval << endl;
		fread(&k,4,1,f);
		fseek(f,ChangeBO(k),SEEK_CUR);
	}


	fclose(f);


	for(FuncVec::iterator fit=vf->begin();fit!=vf->end();fit++){
		pf=*fit;
		
		if(doprint) ofs << "FUNC - ";
		if(doprint) PrintType(&pf->rettype);
		if(doprint) ofs << " "<< pf->name << "(";
		for(Varlist::iterator vit=pf->vl.begin();vit!=pf->vl.end();vit++){
			if(vit!=pf->vl.begin()) if(doprint) ofs << ",";
			pv=(*vit);
			if(doprint) PrintType(&pv->type);
		}
		if(doprint) ofs << ")" << endl;
	}

	return vf;

}

void PrintConstantPool(ConstantPool& cp){
	int i;

	for(i=1;i<cp.size();i++){
		ofs << "CP[" << i << "]\t: " << cp[i].stype << "\t- ";
		switch(cp[i].tag){
		case CP_UTF8:
			//
			ofs << "\"" << cp[i].sval << "\""<< endl;
			break;
		case CP_INTEGER:
			//int
			ofs << dec << cp[i].ival[0] << endl;
			break;
		case CP_FLOAT:
			//float
			ofs << dec << cp[i].fval << endl;
			break;
		case CP_LONG:
			ofs << endl;
			break;
		case CP_DOUBLE:
			ofs << dec << cp[i].dval << endl;
			i++;
			break;
		case CP_CLASS:
			ofs << dec << "(" << cp[i].ival[0] << ") - \"" << cp[cp[i].ival[0]].sval << "\"" << endl;
			break;
		case CP_STRING:
			ofs << dec << "(" << cp[i].ival[0] << ") - \"" << cp[cp[i].ival[0]].sval << "\"" << endl;
			break;
		case CP_FIELD:
		case CP_METHOD:
		case CP_INTERFACEMETHOD:
			ofs << "(" << cp[i].ival[0] << "," << cp[i].ival[1] << ") - ";
			ofs << cp[cp[cp[i].ival[0]].ival[0]].sval << ".";
			ofs << cp[cp[cp[i].ival[1]].ival[0]].sval << " - ";
			ofs << cp[cp[cp[i].ival[1]].ival[1]].sval << endl;
			break;
		case CP_NAMEANDTYPE:
			ofs << "(" << cp[i].ival[0] << "," << cp[i].ival[1] << ") - ";
			ofs << cp[cp[i].ival[0]].sval << " - ";
			ofs << cp[cp[i].ival[1]].sval << endl;
			break;
		default:
			break;
		}
	}

}